Index: fedd/abac-src/atnvis/geni/mit/Alice.prop
===================================================================
--- fedd/abac-src/atnvis/geni/mit/Alice.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/Alice.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,142 @@
+subject = Alice
+
+update.1.location = remote
+
+update.1.1.type = node
+update.1.1.name = MIT: GENI.CTFaccess <<-?- Alice
+update.1.1.nodeType = RoleTarget
+update.1.1.isRoot = True
+
+update.1.2.type = node
+update.1.2.nodeType = RoleTarget
+update.1.2.name = MIT: GENI.CTFaccess <<-?- Alice
+update.1.2.processing = unprocessed
+update.1.2.satisfied = Unknown
+
+update.1.3.type = node
+update.1.3.nodeType = RoleTarget
+update.1.3.name = MIT: GENI.CTFaccess <<-?- Alice
+update.1.3.processing = unprocessed
+update.1.3.satisfied = Unknown
+
+update.1.4.type = edge
+update.1.4.edgeType = Implication
+update.1.4.parentName = MIT: GENI.CTFaccess <<-?- Alice
+update.1.4.childName = MIT: ACM.CTFrep.CTFcontestant <<-?- Alice
+update.1.4.childType = LinkedRoleTarget
+update.1.4.childProcessing = opponent
+update.1.4.evidence.1 = GENI.CTFaccess<-ACM.CTFrep.CTFcontestant
+
+update.1.5.type = node
+update.1.5.nodeType = LinkedRoleTarget
+update.1.5.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Alice
+update.1.5.processing = opponent
+update.1.5.satisfied = Unknown
+
+update.1.6.type = node
+update.1.6.nodeType = RoleTarget
+update.1.6.name = MIT: GENI.CTFaccess <<-?- Alice
+update.1.6.processing = opponent
+update.1.6.satisfied = Unknown
+
+update.1.7.type = node
+update.1.7.name = MIT: GENI.CTFaccess <<-?- Alice
+update.1.7.processing = verifier
+
+update.1.8.type = edge
+update.1.8.edgeType = Implication
+update.1.8.parentName = MIT: ACM.CTFrep.CTFcontestant <<-?- Alice
+update.1.8.childName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Alice
+update.1.8.childType = LinkedRoleTarget
+update.1.8.childProcessing = opponent
+
+update.1.9.type = node
+update.1.9.nodeType = LinkedRoleTarget
+update.1.9.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Alice
+update.1.9.processing = opponent
+update.1.9.satisfied = Unknown
+
+update.1.10.type = node
+update.1.10.nodeType = LinkedRoleTarget
+update.1.10.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Alice
+update.1.10.processing = opponent
+update.1.10.satisfied = Unknown
+
+update.1.11.type = node
+update.1.11.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Alice
+update.1.11.processing = verifier
+
+update.1.12.type = edge
+update.1.12.edgeType = LinkingMonitor
+update.1.12.parentName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Alice
+update.1.12.childName = MIT: ?X.CTFcontestant <<-?- Alice
+update.1.12.childType = LinkingGoal
+update.1.12.childProcessing = verifier
+
+update.1.13.type = node
+update.1.13.nodeType = LinkingGoal
+update.1.13.name = MIT: ?X.CTFcontestant <<-?- Alice
+update.1.13.processing = verifier
+update.1.13.satisfied = Incomplete
+
+update.2.location = local
+
+update.2.1.type = edge
+update.2.1.edgeType = LinkingSolution
+update.2.1.parentName = MIT: ?X.CTFcontestant <<-?- Alice
+update.2.1.childName = MIT: USC.CTFcontestant <<-?- Alice
+update.2.1.childType = RoleTarget
+update.2.1.childProcessing = verifier
+
+update.2.2.type = node
+update.2.2.nodeType = RoleTarget
+update.2.2.name = MIT: USC.CTFcontestant <<-?- Alice
+update.2.2.processing = verifier
+update.2.2.satisfied = Unknown
+
+update.2.3.type = node
+update.2.3.nodeType = LinkingGoal
+update.2.3.name = MIT: ?X.CTFcontestant <<-?- Alice
+update.2.3.processing = fully
+update.2.3.satisfied = Incomplete
+
+update.2.4.type = node
+update.2.4.name = MIT: ?X.CTFcontestant <<-?- Alice
+update.2.4.processing = opponent
+
+update.2.5.type = edge
+update.2.5.edgeType = Implication
+update.2.5.parentName = MIT: USC.CTFcontestant <<-?- Alice
+update.2.5.childName = MIT: Alice <<-?- Alice
+update.2.5.childType = TrivialTarget
+update.2.5.childProcessing = fully
+update.2.5.evidence.1 = USC.CTFcontestant<-Alice
+
+update.2.6.type = node
+update.2.6.nodeType = TrivialTarget
+update.2.6.name = MIT: Alice <<-?- Alice
+update.2.6.processing = fully
+update.2.6.satisfied = Satisfied
+
+update.2.7.type = node
+update.2.7.nodeType = RoleTarget
+update.2.7.name = MIT: USC.CTFcontestant <<-?- Alice
+update.2.7.processing = verifier
+update.2.7.satisfied = Unknown
+
+update.2.8.type = node
+update.2.8.nodeType = RoleTarget
+update.2.8.name = MIT: USC.CTFcontestant <<-?- Alice
+update.2.8.processing = verifier
+update.2.8.satisfied = Satisfied
+
+update.2.9.type = node
+update.2.9.nodeType = LinkingGoal
+update.2.9.name = MIT: ?X.CTFcontestant <<-?- Alice
+update.2.9.processing = fully
+update.2.9.satisfied = Complete
+
+update.2.10.type = node
+update.2.10.name = MIT: USC.CTFcontestant <<-?- Alice
+update.2.10.processing = opponent
+
Index: fedd/abac-src/atnvis/geni/mit/Bill.prop
===================================================================
--- fedd/abac-src/atnvis/geni/mit/Bill.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/Bill.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,142 @@
+subject = Bill
+
+update.1.location = remote
+
+update.1.1.type = node
+update.1.1.name = MIT: GENI.CTFaccess <<-?- Bill
+update.1.1.nodeType = RoleTarget
+update.1.1.isRoot = True
+
+update.1.2.type = node
+update.1.2.nodeType = RoleTarget
+update.1.2.name = MIT: GENI.CTFaccess <<-?- Bill
+update.1.2.processing = unprocessed
+update.1.2.satisfied = Unknown
+
+update.1.3.type = node
+update.1.3.nodeType = RoleTarget
+update.1.3.name = MIT: GENI.CTFaccess <<-?- Bill
+update.1.3.processing = unprocessed
+update.1.3.satisfied = Unknown
+
+update.1.4.type = edge
+update.1.4.edgeType = Implication
+update.1.4.parentName = MIT: GENI.CTFaccess <<-?- Bill
+update.1.4.childName = MIT: ACM.CTFrep.CTFcontestant <<-?- Bill
+update.1.4.childType = LinkedRoleTarget
+update.1.4.childProcessing = opponent
+update.1.4.evidence.1 = GENI.CTFaccess<-ACM.CTFrep.CTFcontestant
+
+update.1.5.type = node
+update.1.5.nodeType = LinkedRoleTarget
+update.1.5.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Bill
+update.1.5.processing = opponent
+update.1.5.satisfied = Unknown
+
+update.1.6.type = node
+update.1.6.nodeType = RoleTarget
+update.1.6.name = MIT: GENI.CTFaccess <<-?- Bill
+update.1.6.processing = opponent
+update.1.6.satisfied = Unknown
+
+update.1.7.type = node
+update.1.7.name = MIT: GENI.CTFaccess <<-?- Bill
+update.1.7.processing = verifier
+
+update.1.8.type = edge
+update.1.8.edgeType = Implication
+update.1.8.parentName = MIT: ACM.CTFrep.CTFcontestant <<-?- Bill
+update.1.8.childName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Bill
+update.1.8.childType = LinkedRoleTarget
+update.1.8.childProcessing = opponent
+
+update.1.9.type = node
+update.1.9.nodeType = LinkedRoleTarget
+update.1.9.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Bill
+update.1.9.processing = opponent
+update.1.9.satisfied = Unknown
+
+update.1.10.type = node
+update.1.10.nodeType = LinkedRoleTarget
+update.1.10.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Bill
+update.1.10.processing = opponent
+update.1.10.satisfied = Unknown
+
+update.1.11.type = node
+update.1.11.name = MIT: ACM.CTFrep.CTFcontestant <<-?- Bill
+update.1.11.processing = verifier
+
+update.1.12.type = edge
+update.1.12.edgeType = LinkingMonitor
+update.1.12.parentName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- Bill
+update.1.12.childName = MIT: ?X.CTFcontestant <<-?- Bill
+update.1.12.childType = LinkingGoal
+update.1.12.childProcessing = verifier
+
+update.1.13.type = node
+update.1.13.nodeType = LinkingGoal
+update.1.13.name = MIT: ?X.CTFcontestant <<-?- Bill
+update.1.13.processing = verifier
+update.1.13.satisfied = Incomplete
+
+update.2.location = local
+
+update.2.1.type = edge
+update.2.1.edgeType = LinkingSolution
+update.2.1.parentName = MIT: ?X.CTFcontestant <<-?- Bill
+update.2.1.childName = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.1.childType = RoleTarget
+update.2.1.childProcessing = verifier
+
+update.2.2.type = node
+update.2.2.nodeType = RoleTarget
+update.2.2.name = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.2.processing = verifier
+update.2.2.satisfied = Unknown
+
+update.2.3.type = node
+update.2.3.nodeType = LinkingGoal
+update.2.3.name = MIT: ?X.CTFcontestant <<-?- Bill
+update.2.3.processing = fully
+update.2.3.satisfied = Incomplete
+
+update.2.4.type = node
+update.2.4.name = MIT: ?X.CTFcontestant <<-?- Bill
+update.2.4.processing = opponent
+
+update.2.5.type = edge
+update.2.5.edgeType = Implication
+update.2.5.parentName = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.5.childName = MIT: Bill <<-?- Bill
+update.2.5.childType = TrivialTarget
+update.2.5.childProcessing = fully
+update.2.5.evidence.1 = Mike.CTFcontestant<-Bill
+
+update.2.6.type = node
+update.2.6.nodeType = TrivialTarget
+update.2.6.name = MIT: Bill <<-?- Bill
+update.2.6.processing = fully
+update.2.6.satisfied = Satisfied
+
+update.2.7.type = node
+update.2.7.nodeType = RoleTarget
+update.2.7.name = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.7.processing = verifier
+update.2.7.satisfied = Unknown
+
+update.2.8.type = node
+update.2.8.nodeType = RoleTarget
+update.2.8.name = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.8.processing = verifier
+update.2.8.satisfied = Satisfied
+
+update.2.9.type = node
+update.2.9.nodeType = LinkingGoal
+update.2.9.name = MIT: ?X.CTFcontestant <<-?- Bill
+update.2.9.processing = fully
+update.2.9.satisfied = Complete
+
+update.2.10.type = node
+update.2.10.name = MIT: Mike.CTFcontestant <<-?- Bill
+update.2.10.processing = opponent
+
Index: fedd/abac-src/atnvis/geni/mit/James.prop
===================================================================
--- fedd/abac-src/atnvis/geni/mit/James.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/James.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,143 @@
+subject = James
+
+update.1.location = remote
+
+update.1.1.type = node
+update.1.1.name = MIT: GENI.CTFaccess <<-?- James
+update.1.1.nodeType = RoleTarget
+update.1.1.isRoot = True
+
+update.1.2.type = node
+update.1.2.nodeType = RoleTarget
+update.1.2.name = MIT: GENI.CTFaccess <<-?- James
+update.1.2.processing = unprocessed
+update.1.2.satisfied = Unknown
+
+update.1.3.type = node
+update.1.3.nodeType = RoleTarget
+update.1.3.name = MIT: GENI.CTFaccess <<-?- James
+update.1.3.processing = unprocessed
+update.1.3.satisfied = Unknown
+
+update.1.4.type = edge
+update.1.4.edgeType = Implication
+update.1.4.parentName = MIT: GENI.CTFaccess <<-?- James
+update.1.4.childName = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.4.childType = LinkedRoleTarget
+update.1.4.childProcessing = opponent
+update.1.4.evidence.1 = GENI.CTFaccess<-ACM.CTFrep.CTFcontestant
+
+update.1.5.type = node
+update.1.5.nodeType = LinkedRoleTarget
+update.1.5.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.5.processing = opponent
+update.1.5.satisfied = Unknown
+
+update.1.6.type = node
+update.1.6.nodeType = RoleTarget
+update.1.6.name = MIT: GENI.CTFaccess <<-?- James
+update.1.6.processing = opponent
+update.1.6.satisfied = Unknown
+
+update.1.7.type = node
+update.1.7.name = MIT: GENI.CTFaccess <<-?- James
+update.1.7.processing = verifier
+
+update.1.8.type = edge
+update.1.8.edgeType = Implication
+update.1.8.parentName = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.8.childName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.8.childType = LinkedRoleTarget
+update.1.8.childProcessing = opponent
+
+update.1.9.type = node
+update.1.9.nodeType = LinkedRoleTarget
+update.1.9.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.9.processing = opponent
+update.1.9.satisfied = Unknown
+
+update.1.10.type = node
+update.1.10.nodeType = LinkedRoleTarget
+update.1.10.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.10.processing = opponent
+update.1.10.satisfied = Unknown
+
+update.1.11.type = node
+update.1.11.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.11.processing = verifier
+
+update.1.12.type = edge
+update.1.12.edgeType = LinkingMonitor
+update.1.12.parentName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.12.childName = MIT: ?X.CTFcontestant <<-?- James
+update.1.12.childType = LinkingGoal
+update.1.12.childProcessing = verifier
+
+update.1.13.type = node
+update.1.13.nodeType = LinkingGoal
+update.1.13.name = MIT: ?X.CTFcontestant <<-?- James
+update.1.13.processing = verifier
+update.1.13.satisfied = Incomplete
+
+update.2.location = local
+
+update.2.1.type = edge
+update.2.1.edgeType = LinkingSolution
+update.2.1.parentName = MIT: ?X.CTFcontestant <<-?- James
+update.2.1.childName = MIT: MIT.CTFcontestant <<-?- James
+update.2.1.childType = RoleTarget
+update.2.1.childProcessing = verifier
+
+update.2.2.type = node
+update.2.2.nodeType = RoleTarget
+update.2.2.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.2.processing = verifier
+update.2.2.satisfied = Unknown
+
+update.2.3.type = node
+update.2.3.nodeType = LinkingGoal
+update.2.3.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.3.processing = fully
+update.2.3.satisfied = Incomplete
+
+update.2.4.type = node
+update.2.4.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.4.processing = opponent
+
+update.2.5.type = edge
+update.2.5.edgeType = Implication
+update.2.5.parentName = MIT: MIT.CTFcontestant <<-?- James
+update.2.5.childName = MIT: James <<-?- James
+update.2.5.childType = TrivialTarget
+update.2.5.childProcessing = fully
+update.2.5.evidence.1 = MIT.student<-James
+update.2.5.evidence.2 = MIT.CTFcontestant<-MIT.student
+
+update.2.6.type = node
+update.2.6.nodeType = TrivialTarget
+update.2.6.name = MIT: James <<-?- James
+update.2.6.processing = fully
+update.2.6.satisfied = Satisfied
+
+update.2.7.type = node
+update.2.7.nodeType = RoleTarget
+update.2.7.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.7.processing = verifier
+update.2.7.satisfied = Unknown
+
+update.2.8.type = node
+update.2.8.nodeType = RoleTarget
+update.2.8.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.8.processing = verifier
+update.2.8.satisfied = Satisfied
+
+update.2.9.type = node
+update.2.9.nodeType = LinkingGoal
+update.2.9.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.9.processing = fully
+update.2.9.satisfied = Complete
+
+update.2.10.type = node
+update.2.10.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.10.processing = opponent
+
Index: fedd/abac-src/atnvis/geni/mit/MIT.prop
===================================================================
--- fedd/abac-src/atnvis/geni/mit/MIT.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/MIT.prop	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,216 @@
+subject = MIT
+
+update.1.location = local
+
+update.1.1.type = node
+update.1.1.name = MIT: GENI.CTFaccess <<-?- James
+update.1.1.nodeType = RoleTarget
+update.1.1.isRoot = True
+
+update.1.2.type = node
+update.1.2.nodeType = RoleTarget
+update.1.2.name = MIT: GENI.CTFaccess <<-?- James
+update.1.2.processing = unprocessed
+update.1.2.satisfied = Unknown
+
+update.1.3.type = node
+update.1.3.nodeType = RoleTarget
+update.1.3.name = MIT: GENI.CTFaccess <<-?- James
+update.1.3.processing = unprocessed
+update.1.3.satisfied = Unknown
+
+update.1.4.type = edge
+update.1.4.edgeType = Implication
+update.1.4.parentName = MIT: GENI.CTFaccess <<-?- James
+update.1.4.childName = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.4.childType = LinkedRoleTarget
+update.1.4.childProcessing = opponent
+update.1.4.evidence.1 = GENI.CTFaccess<-ACM.CTFrep.CTFcontestant
+
+update.1.5.type = node
+update.1.5.nodeType = LinkedRoleTarget
+update.1.5.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.5.processing = opponent
+update.1.5.satisfied = Unknown
+
+update.1.6.type = node
+update.1.6.nodeType = RoleTarget
+update.1.6.name = MIT: GENI.CTFaccess <<-?- James
+update.1.6.processing = opponent
+update.1.6.satisfied = Unknown
+
+update.1.7.type = node
+update.1.7.name = MIT: GENI.CTFaccess <<-?- James
+update.1.7.processing = verifier
+
+update.1.8.type = edge
+update.1.8.edgeType = Implication
+update.1.8.parentName = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.8.childName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.8.childType = LinkedRoleTarget
+update.1.8.childProcessing = opponent
+
+update.1.9.type = node
+update.1.9.nodeType = LinkedRoleTarget
+update.1.9.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.9.processing = opponent
+update.1.9.satisfied = Unknown
+
+update.1.10.type = node
+update.1.10.nodeType = LinkedRoleTarget
+update.1.10.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.10.processing = opponent
+update.1.10.satisfied = Unknown
+
+update.1.11.type = node
+update.1.11.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.1.11.processing = verifier
+
+update.1.12.type = edge
+update.1.12.edgeType = LinkingMonitor
+update.1.12.parentName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.1.12.childName = MIT: ?X.CTFcontestant <<-?- James
+update.1.12.childType = LinkingGoal
+update.1.12.childProcessing = verifier
+
+update.1.13.type = node
+update.1.13.nodeType = LinkingGoal
+update.1.13.name = MIT: ?X.CTFcontestant <<-?- James
+update.1.13.processing = verifier
+update.1.13.satisfied = Incomplete
+
+update.2.location = remote
+
+update.2.1.type = edge
+update.2.1.edgeType = LinkingSolution
+update.2.1.parentName = MIT: ?X.CTFcontestant <<-?- James
+update.2.1.childName = MIT: MIT.CTFcontestant <<-?- James
+update.2.1.childType = RoleTarget
+update.2.1.childProcessing = verifier
+
+update.2.2.type = node
+update.2.2.nodeType = RoleTarget
+update.2.2.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.2.processing = verifier
+update.2.2.satisfied = Unknown
+
+update.2.3.type = node
+update.2.3.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.3.processing = opponent
+
+update.2.4.type = node
+update.2.4.nodeType = LinkingGoal
+update.2.4.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.4.processing = fully
+update.2.4.satisfied = Incomplete
+
+update.2.5.type = edge
+update.2.5.edgeType = Implication
+update.2.5.parentName = MIT: MIT.CTFcontestant <<-?- James
+update.2.5.childName = MIT: James <<-?- James
+update.2.5.childType = TrivialTarget
+update.2.5.childProcessing = fully
+update.2.5.evidence.1 = MIT.student<-James
+update.2.5.evidence.2 = MIT.CTFcontestant<-MIT.student
+
+update.2.6.type = node
+update.2.6.nodeType = TrivialTarget
+update.2.6.name = MIT: James <<-?- James
+update.2.6.processing = fully
+update.2.6.satisfied = Satisfied
+
+update.2.7.type = node
+update.2.7.nodeType = RoleTarget
+update.2.7.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.7.processing = verifier
+update.2.7.satisfied = Unknown
+
+update.2.8.type = node
+update.2.8.nodeType = RoleTarget
+update.2.8.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.8.processing = verifier
+update.2.8.satisfied = Satisfied
+
+update.2.9.type = node
+update.2.9.nodeType = LinkingGoal
+update.2.9.name = MIT: ?X.CTFcontestant <<-?- James
+update.2.9.processing = fully
+update.2.9.satisfied = Complete
+
+update.2.10.type = node
+update.2.10.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.2.10.processing = verifier
+
+update.2.11.type = node
+update.2.11.name = MIT: MIT.CTFcontestant <<-?- James
+update.2.11.processing = opponent
+
+update.3.location = local
+
+update.3.1.type = edge
+update.3.1.edgeType = LinkingImplication
+update.3.1.parentName = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.3.1.childName = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.1.childType = RoleTarget
+update.3.1.childProcessing = opponent
+
+update.3.2.type = node
+update.3.2.nodeType = RoleTarget
+update.3.2.name = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.2.processing = opponent
+update.3.2.satisfied = Unknown
+
+update.3.3.type = node
+update.3.3.nodeType = LinkedRoleTarget
+update.3.3.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.3.3.processing = fully
+update.3.3.satisfied = Unknown
+
+update.3.4.type = edge
+update.3.4.edgeType = Implication
+update.3.4.parentName = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.4.childName = MIT: Mike <<-?- MIT
+update.3.4.childType = TrivialTarget
+update.3.4.childProcessing = fully
+update.3.4.evidence.1 = UCLA.ACMofficer<-Mike
+
+update.3.5.type = node
+update.3.5.nodeType = TrivialTarget
+update.3.5.name = MIT: Mike <<-?- MIT
+update.3.5.processing = fully
+update.3.5.satisfied = Satisfied
+
+update.3.6.type = node
+update.3.6.nodeType = RoleTarget
+update.3.6.name = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.6.processing = opponent
+update.3.6.satisfied = Unknown
+
+update.3.7.type = node
+update.3.7.nodeType = RoleTarget
+update.3.7.name = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.7.processing = opponent
+update.3.7.satisfied = Satisfied
+
+update.3.8.type = node
+update.3.8.nodeType = LinkedRoleTarget
+update.3.8.name = MIT: UCLA.ACMofficer.CTFcontestant <<-?- James
+update.3.8.processing = fully
+update.3.8.satisfied = Satisfied
+
+update.3.9.type = node
+update.3.9.nodeType = LinkedRoleTarget
+update.3.9.name = MIT: ACM.CTFrep.CTFcontestant <<-?- James
+update.3.9.processing = fully
+update.3.9.satisfied = Satisfied
+
+update.3.10.type = node
+update.3.10.nodeType = RoleTarget
+update.3.10.name = MIT: GENI.CTFaccess <<-?- James
+update.3.10.processing = fully
+update.3.10.satisfied = Satisfied
+
+update.3.11.type = node
+update.3.11.name = MIT: UCLA.ACMofficer <<-?- MIT
+update.3.11.processing = verifier
+
Index: fedd/abac-src/atnvis/geni/mit/atnvis.properties
===================================================================
--- fedd/abac-src/atnvis/geni/mit/atnvis.properties	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/atnvis.properties	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,93 @@
+# Window properties
+atnvis.window.Title = Automated Trust Negotiation Visualization
+atnvis.window.Height = 768
+atnvis.window.Width = 1024
+
+
+# Control properties
+atnvis.control.DefaultDelay = 500
+atnvis.control.Loop = true
+
+
+# Parser
+atnvis.parser=com.algomagic.atn.PropertyLogParser
+atnvis.parser.IgnoreProcessing = true
+
+
+# Graph properties
+atnvis.graph.Scale = 0.8
+atnvis.graph.ShadowColor = gray60
+
+
+# Default node properties
+atnvis.node.Default.style = solid,filled
+atnvis.node.Default.color = purple
+atnvis.node.Default.shape = box
+atnvis.node.Default.fontname = TimesRoman
+atnvis.node.Default.fontcolor = black
+atnvis.node.Default.fontsize = 14
+atnvis.node.Default.fontstyle = normal
+
+
+# Default edge properties:
+atnvis.edge.Default.style = solid
+atnvis.edge.Default.color = black
+atnvis.edge.Default.direction = back
+
+
+atnvis.node.StandardTarget.shape = octagon
+atnvis.node.RoleTarget.shape = octagon
+atnvis.node.IntersectionTarget.shape = house
+atnvis.node.LinkingGoal.shape = box
+atnvis.node.LinkedRoleTarget.shape = trapezium
+atnvis.node.TrivialTarget.shape = invhouse
+
+
+atnvis.node.processed.Unprocessed.color = yellow
+atnvis.node.processed.Opponent.color = lightblue
+atnvis.node.processed.Verifier.color = lightgoldenrod
+atnvis.node.processed.Fully.color = lightseagreen
+
+atnvis.node.satisfied.Satisfied.color = green
+atnvis.node.satisfied.Failed.color = red
+atnvis.node.satisfied.Unknown.color = white
+
+#atnvis.node.satisfied.Satisfied.shape = tripleoctagon
+#atnvis.node.satisfied.Failed.shape = doubleoctagon
+
+
+# Standard Implication Edge properties
+atnvis.edge.Implication.color = purple3
+atnvis.edge.Implication.style = solid
+atnvis.edge.Implication.color.bold = purple1
+atnvis.edge.Implication.style.bold = dashed
+
+# Linking-Monitor Edge properties
+atnvis.edge.LinkingMonitor.color = royalblue3
+atnvis.edge.LinkingMonitor.style = solid
+atnvis.edge.LinkingMonitor.color.bold = royalblue1
+atnvis.edge.LinkingMonitor.style.bold = dashed
+
+# Linking-Solution Edge properties
+atnvis.edge.LinkingSolution.color = gold3
+atnvis.edge.LinkingSolution.style = solid
+atnvis.edge.LinkingSolution.color.bold = gold1
+atnvis.edge.LinkingSolution.style.bold = dashed
+
+# Linking-Implication Edge properties
+atnvis.edge.LinkingImplication.color = darkolivegreen3
+atnvis.edge.LinkingImplication.style = solid
+atnvis.edge.LinkingImplication.color.bold = darkolivegreen1
+atnvis.edge.LinkingImplication.style.bold = dashed
+
+# Intersection Edge properties
+atnvis.edge.Intersection.color = orange3
+atnvis.edge.Intersection.style = solid
+atnvis.edge.Intersection.color.bold = orange1
+atnvis.edge.Intersection.style.bold = dashed
+
+# Control Edge properties
+atnvis.edge.Control.color = firebrick3
+atnvis.edge.Control.style = solid
+atnvis.edge.Control.color.bold = firebrick1
+atnvis.edge.Control.style.bold = dashed
Index: fedd/abac-src/atnvis/geni/mit/gojames
===================================================================
--- fedd/abac-src/atnvis/geni/mit/gojames	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
+++ fedd/abac-src/atnvis/geni/mit/gojames	(revision 728001e2221b78f3f0a0a56f19bac83d82049f42)
@@ -0,0 +1,1 @@
+java -jar ../../atnvis.jar James.prop MIT.prop