Index: fedd/fedd.py
===================================================================
--- fedd/fedd.py	(revision ec4fb429a3fab87363f4ff5ebc4b52e33b6c841b)
+++ fedd/fedd.py	(revision 7454054cd207e4b8769862387912f331cd9bd6a8)
@@ -8,5 +8,5 @@
 from fedd.config_parser import config_parser
 from fedd.util import fedd_ssl_context
-from fedd.fedd_deter_impl import new_feddservice
+from fedd.deter_impl import new_feddservice
 
 from threading import *
Index: fedd/fedd/deter_impl.py
===================================================================
--- fedd/fedd/deter_impl.py	(revision 7454054cd207e4b8769862387912f331cd9bd6a8)
+++ fedd/fedd/deter_impl.py	(revision 7454054cd207e4b8769862387912f331cd9bd6a8)
@@ -0,0 +1,51 @@
+#!/usr/local/bin/python
+
+from access import access
+from experiment_control import experiment_control_local
+from split import split_local
+
+from authorizer import authorizer
+
+class deter_impl:
+    """
+    The implementation of access control based on mapping users to projects.
+
+    Users can be mapped to existing projects or have projects created
+    dynamically.  This implements both direct requests and proxies.
+    """
+    # Used by the SOAP caller
+    soap_namespaces = ('http://www.isi.edu/faber/fedd.wsdl',
+	    'http://www.isi.edu/faber/fedd_internal.wsdl')
+
+    def __init__(self, config=None):
+	"""
+	Initializer.  Uses the parsed configuration to create appropriate
+	components.
+	"""
+	self.soap_services = { }
+	self.xmlrpc_services = { }
+	self.auth = authorizer()
+
+	if config:
+	    self.cert_file = config.get("globals", "cert_file");
+	    self.cert_pwd = config.get("globals", "cert_pwd");
+	    self.trusted_certs = config.get("globals", "trusted_certs");
+
+	    if config.has_section("access"):
+		self.access = access(config, self.auth)
+		self.soap_services.update(self.access.soap_services) 
+		self.xmlrpc_services.update(self.access.xmlrpc_services) 
+
+	    if config.has_section("experiment_control"):
+		self.experiment = \
+			experiment_control_local(config, self.auth)
+		self.soap_services.update(self.experiment.soap_services) 
+		self.xmlrpc_services.update(self.experiment.xmlrpc_services) 
+
+	    if config.has_section("splitter"):
+		self.splitter = split_local(config, self.auth)
+		self.soap_services.update(self.splitter.soap_services) 
+		self.xmlrpc_services.update(self.splitter.xmlrpc_services) 
+
+def new_feddservice(config):
+    return deter_impl(config)
Index: fedd/fedd/fedd_deter_impl.py
===================================================================
--- fedd/fedd/fedd_deter_impl.py	(revision ec4fb429a3fab87363f4ff5ebc4b52e33b6c841b)
+++ 	(revision )
@@ -1,51 +1,0 @@
-#!/usr/local/bin/python
-
-from access import access
-from experiment_control import experiment_control_local
-from split import split_local
-
-from authorizer import authorizer
-
-class fedd_deter_impl:
-    """
-    The implementation of access control based on mapping users to projects.
-
-    Users can be mapped to existing projects or have projects created
-    dynamically.  This implements both direct requests and proxies.
-    """
-    # Used by the SOAP caller
-    soap_namespaces = ('http://www.isi.edu/faber/fedd.wsdl',
-	    'http://www.isi.edu/faber/fedd_internal.wsdl')
-
-    def __init__(self, config=None):
-	"""
-	Initializer.  Uses the parsed configuration to create appropriate
-	components.
-	"""
-	self.soap_services = { }
-	self.xmlrpc_services = { }
-	self.auth = authorizer()
-
-	if config:
-	    self.cert_file = config.get("globals", "cert_file");
-	    self.cert_pwd = config.get("globals", "cert_pwd");
-	    self.trusted_certs = config.get("globals", "trusted_certs");
-
-	    if config.has_section("access"):
-		self.access = access(config, self.auth)
-		self.soap_services.update(self.access.soap_services) 
-		self.xmlrpc_services.update(self.access.xmlrpc_services) 
-
-	    if config.has_section("experiment_control"):
-		self.experiment = \
-			experiment_control_local(config, self.auth)
-		self.soap_services.update(self.experiment.soap_services) 
-		self.xmlrpc_services.update(self.experiment.xmlrpc_services) 
-
-	    if config.has_section("splitter"):
-		self.splitter = split_local(config, self.auth)
-		self.soap_services.update(self.splitter.soap_services) 
-		self.xmlrpc_services.update(self.splitter.xmlrpc_services) 
-
-def new_feddservice(config):
-    return fedd_deter_impl(config)